diff --git a/config.c b/config.c
index f56648a6..d47e8156 100644
--- a/config.c
+++ b/config.c
@@ -33,6 +33,7 @@ void config_set_defaults(void)
 	config.item_padding_x	 = 4;
 	config.item_radius	 = 1;
 	config.item_border	 = 0;
+	config.item_halign	 = LEFT;
 	config.sep_height	 = 5;
 
 	config.font		 = NULL; /* Leave as NULL. Set in jgmenu.c */
@@ -113,6 +114,13 @@ static void process_line(char *line)
 		xatoi(&config.item_radius, value, XATOI_NONNEG, "config.item_radius");
 	} else if (!strncmp(option, "item_border", 11)) {
 		xatoi(&config.item_border, value, XATOI_NONNEG, "config.item_border");
+	} else if (!strncmp(option, "item_halign", 11)) {
+		if (!value)
+			return;
+		if (!strcasecmp(value, "left"))
+			config.item_halign = LEFT;
+		else if (!strcasecmp(value, "right"))
+			config.item_halign = RIGHT;
 	} else if (!strncmp(option, "sep_height", 10)) {
 		xatoi(&config.sep_height, value, XATOI_NONNEG, "config.sep_height");
 
diff --git a/config.h b/config.h
index 41452b2d..7fdb2d91 100644
--- a/config.h
+++ b/config.h
@@ -29,6 +29,7 @@ struct config {
 	int item_padding_x;
 	int item_radius;
 	int item_border;
+	enum alignment item_halign;
 	int sep_height;
 
 	char *font;
diff --git a/docs/jgmenurc b/docs/jgmenurc
index d5dbb986..4d9ada56 100644
--- a/docs/jgmenurc
+++ b/docs/jgmenurc
@@ -25,6 +25,7 @@ item_height	  = 25
 item_padding_x	  = 4
 item_radius	  = 1
 item_border	  = 0
+item_halign       = left
 sep_height	  = 5
 
 font		  = Cantarell 10
diff --git a/docs/manual/jgmenu-config.1 b/docs/manual/jgmenu-config.1
index 0abb1f94..2c1e9240 100644
--- a/docs/manual/jgmenu-config.1
+++ b/docs/manual/jgmenu-config.1
@@ -350,6 +350,20 @@ item_border = \f[B]integer\f[]
 .PP
 \ \ \ \ See equivalent \f[C]menu_\f[] variable definitions.
 .PP
+item_halign = (left | right)
+.PP
+\ \ \ \ Horizontal alignment of actual menu items.
+Items are left\-aligned
+.PD 0
+.P
+.PD
+\ \ \ \ by default.
+If set to right, the option \f[C]arrow_string\f[] should be
+.PD 0
+.P
+.PD
+\ \ \ \ changed too.
+.PP
 sep_height = \f[B]integer\f[]
 .PP
 \ \ \ \ height of separator (defined by ^sep())
diff --git a/docs/manual/jgmenu-config.1.md b/docs/manual/jgmenu-config.1.md
index ea198efc..efee75ee 100644
--- a/docs/manual/jgmenu-config.1.md
+++ b/docs/manual/jgmenu-config.1.md
@@ -165,6 +165,12 @@ item_border = __integer__
 
     See equivalent `menu_` variable definitions.  
 
+item_halign = (left | right)  
+
+    Horizontal alignment of actual menu items. Items are left-aligned  
+    by default. If set to right, the option `arrow_string` should be  
+    changed too.  
+
 sep_height = __integer__  
 
     height of separator (defined by ^sep())
diff --git a/jgmenu-init.sh b/jgmenu-init.sh
index e55272e7..95ffa402 100755
--- a/jgmenu-init.sh
+++ b/jgmenu-init.sh
@@ -30,6 +30,7 @@ item_height       = 25
 item_padding_x    = 4
 item_radius       = 1
 item_border       = 0
+item_halign       = left
 sep_height        = 5
 font              = Cantarell 10
 icon_size         = 22
diff --git a/jgmenu.c b/jgmenu.c
index 722fa3ba..e679a21e 100644
--- a/jgmenu.c
+++ b/jgmenu.c
@@ -347,7 +347,8 @@ void draw_item_sep_with_text(struct item *p)
 		text_x_coord += config.icon_size + config.item_padding_x;
 
 	ui_insert_text(parse_caret_action(p->name, "^sep("), text_x_coord,
-		       p->area.y, p->area.h, config.color_sep_fg);
+		       p->area.y, p->area.h, p->area.w, config.color_sep_fg,
+		       config.item_halign);
 }
 
 void draw_item_bg_norm(struct item *p)
@@ -373,23 +374,57 @@ void draw_item_text(struct item *p)
 {
 	int text_x_coord;
 
-	text_x_coord = p->area.x + config.item_padding_x;
-	if (config.icon_size)
-		text_x_coord += config.icon_size + config.item_padding_x;
+	if (config.item_halign != RIGHT) {
+		text_x_coord = p->area.x + config.item_padding_x;
+		if (config.icon_size)
+			text_x_coord += config.icon_size + config.item_padding_x;
+	} else {
+		text_x_coord = p->area.x - config.item_padding_x;
+		if (config.icon_size)
+			text_x_coord -= config.icon_size + config.item_padding_x;
+	}
 
 	if (p == menu.sel)
 		ui_insert_text(p->name, text_x_coord, p->area.y,
-			       p->area.h, config.color_sel_fg);
+			       p->area.h, p->area.w, config.color_sel_fg,
+			       config.item_halign);
 	else
 		ui_insert_text(p->name, text_x_coord, p->area.y,
-			       p->area.h, config.color_norm_fg);
+			       p->area.h, p->area.w, config.color_norm_fg,
+			       config.item_halign);
+}
+
+void draw_submenu_arrow(struct item *p)
+{
+	if (config.item_halign != RIGHT)
+		ui_insert_text(config.arrow_string, p->area.x + p->area.w -
+			       config.item_padding_x - (config.arrow_width * 0.7), p->area.y,
+			       p->area.h, p->area.w, config.color_norm_fg,
+			       config.item_halign);
+	else
+		ui_insert_text(config.arrow_string, p->area.x + config.item_padding_x,
+			       p->area.y, p->area.h, config.arrow_width * 0.7,
+			       config.color_norm_fg, config.item_halign);
+}
+
+void draw_icon(struct item *p)
+{
+	int icon_y_coord;
+
+	icon_y_coord = p->area.y + (config.item_height - config.icon_size) / 2;
+	if (config.item_halign != RIGHT)
+		ui_insert_image(p->icon, p->area.x + 1, icon_y_coord,
+				config.icon_size);
+	else
+		ui_insert_image(p->icon, p->area.x + p->area.w - config.icon_size - 1,
+				icon_y_coord, config.icon_size);
+
 }
 
 void draw_menu(void)
 {
 	struct item *p;
 	int w;
-	int icon_y_coord;
 
 	w = geo_get_menu_width();
 
@@ -416,9 +451,7 @@ void draw_menu(void)
 		/* Draw submenu arrow */
 		if (config.arrow_show && (!strncmp(p->cmd, "^checkout(", 10) ||
 					  !strncmp(p->cmd, "^sub(", 5)))
-			ui_insert_text(config.arrow_string, p->area.x + p->area.w -
-				       config.item_padding_x - (config.arrow_width * 0.7), p->area.y,
-				       p->area.h, config.color_norm_fg);
+			draw_submenu_arrow(p);
 
 		/* Draw menu items text */
 		if (p->selectable)
@@ -429,10 +462,8 @@ void draw_menu(void)
 			draw_item_sep_with_text(p);
 
 		/* Draw Icons */
-		if (config.icon_size && p->icon) {
-			icon_y_coord = p->area.y + (config.item_height - config.icon_size) / 2;
-			ui_insert_image(p->icon, p->area.x + 1, icon_y_coord, config.icon_size);
-		}
+		if (config.icon_size && p->icon)
+			draw_icon(p);
 
 		if (p == menu.last)
 			break;
diff --git a/x11-ui.c b/x11-ui.c
index 57899193..855e4fcd 100644
--- a/x11-ui.c
+++ b/x11-ui.c
@@ -298,13 +298,18 @@ void ui_draw_line(double x0, double y0, double x1, double y1, double line_width,
 	cairo_stroke(ui->c);
 }
 
-void ui_insert_text(char *s, int x, int y, int h, double *rgba)
+void ui_insert_text(char *s, int x, int y, int h, int w, double *rgba,
+		    enum alignment align)
 {
 	/* Used to centre vertical alignment */
 	int offset;
 
 	offset = (h - ui->font_height_actual) / 2;
 
+	if (align == RIGHT) {
+		pango_layout_set_width(ui->pangolayout, w * PANGO_SCALE);
+		pango_layout_set_alignment(ui->pangolayout, PANGO_ALIGN_RIGHT);
+	}
 	pango_layout_set_text(ui->pangolayout, s, -1);
 	pango_layout_set_font_description(ui->pangolayout, ui->pangofont);
 	cairo_set_source_rgba(ui->c, rgba[0], rgba[1], rgba[2], rgba[3]);
diff --git a/x11-ui.h b/x11-ui.h
index 9688d10a..9d7c7545 100644
--- a/x11-ui.h
+++ b/x11-ui.h
@@ -9,6 +9,8 @@
 #include <pango/pangocairo.h>
 #include <librsvg/rsvg.h>
 
+#include "align.h"
+
 struct area {
 	int x, y, w, h;
 };
@@ -49,7 +51,8 @@ void ui_draw_rectangle_rounded_at_top(double x, double y, double w, double h, do
 void ui_draw_rectangle(double x, double y, double w, double h, double radius, double line_width,
 		       int fill, double *rgba);
 void ui_draw_line(double x0, double y0, double x1, double y1, double line_width, double *rgba);
-void ui_insert_text(char *s, int x, int y, int h, double *rgba);
+void ui_insert_text(char *s, int x, int y, int h, int w, double *rgba,
+		    enum alignment align);
 struct point ui_get_text_size(const char *str, const char *fontdesc);
 int ui_is_point_in_area(struct point p, struct area a);
 void ui_map_window(unsigned int w, unsigned int h);
